<div class="animated fadeIn">
    <div class="card" style="padding: 0.2rem">
        <div class="card-header bg-gray-200 text-primary d-flex bd-highlight mb-3">
            <div class="mr-auto p-2 bd-highlight">
                <i class="fa fa-plus-circle text-primary"></i> {{TITLE}}
            </div>
            <button class="btn btn-sm rounded btn-outline-primary p-2 bd-highlight" (click)="addFieldList(addField)">
                <i class="fa fa-plus"></i> Agregar campo
            </button>
<!--            <button style="margin-left: 1rem" class="btn bg-primary rounded p-2 bd-highlight"-->
<!--                    (click)="upFileList(upFile)">-->
<!--                <i class="fa fa-upload"></i> Cargar estructura-->
<!--            </button>-->
            <button style="margin-left: 1rem" class="btn btn-sm rounded btn-outline-danger" (click)="cancel()">
                <i class="fa fa-plus-circle"></i> Regresar
            </button>
        </div>
        <div class="card-body mt-4 p-0">

            <div class="row justify-content-center align-items-center text-primary">

                <div class="col-12 col-md-6 col-lg-3">
                    <div class="form-group">
                        <label class="col-form-label">ID de Lista:</label>
                        <div class="controls">
                            <div class="input-prepend input-group">
                                <div class="input-group-prepend">
                                    <span class="input-group-text"><i class="fa fa-bars text-primary"></i></span>
                                </div>
                                <input [(ngModel)]="idList" type="text" class="form-control">
                            </div>
                        </div>
                    </div>
                </div>

                <div class="col-12 col-md-6 col-lg-3">
                    <div class="form-group">
                        <label class="col-form-label">Descripción:</label>
                        <div class="controls">
                            <div class="input-prepend input-group">
                                <div class="input-group-prepend">
                                    <span class="input-group-text"><i class="fa fa-bars text-primary"></i></span>
                                </div>
                                <input [(ngModel)]="descList" type="text" class="form-control">
                            </div>
                        </div>
                    </div>
                </div>

                <div class="col-12 col-md-6 col-lg-3">
                    <div class="form-group">
                        <label class="col-form-label">Estado:</label>
                        <div class="controls">
                            <div class="input-prepend input-group">
                                <div class="input-group-prepend">
                                    <span class="input-group-text"><i class="fa fa fa-check-circle-o text-primary"></i></span>
                                </div>
                                <select [(ngModel)]="statusList" class="form-control">
                                    <option value="A" selected>Activa</option>
                                    <option value="I">Inactiva</option>
                                </select>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-12 col-md-6 col-lg-3">
                    <div class="form-group">
                        <label class="col-form-label">Externa:</label>
                        <div class="controls">
                            <div class="input-prepend input-group">
                                <div class="input-group-prepend">
                                    <span class="input-group-text"><i class="fa fa fa-check-circle-o text-primary"></i></span>
                                </div>
                                <select [(ngModel)]="extList" class="form-control">
                                    <option value="Externa" selected>SI</option>
                                    <option value="Interna">NO</option>
                                </select>
                            </div>
                        </div>
                    </div>
                </div>

            </div>

            <br>
            <table datatable [dtOptions]="dtOptions" [dtTrigger]="dtTrigger" class="row-border hover">
                <thead class="bg-primary">
                <tr>
                    <th scope="col">Nombre de Campo</th>
                    <th scope="col" class="text-center">Tipo</th>
                    <th scope="col" class="text-center">Obligatorio</th>
                    <th scope="col" class="text-center">Busqueda</th>
                    <th scope="col" class="text-center">Orden</th>
                    <th scope="col" class="text-center">Activo</th>
                    <th scope="col" class="text-center">Subcategoria</th>
                    <th scope="col">Acciones</th>
                </tr>
                </thead>
                <tbody>
                <tr *ngFor="let campo of camposLista">
                    <td>{{ campo.nombre }}</td>
                    <td class="text-center" *ngIf="campo.tipo == 'text'">Texto</td>
                    <td class="text-center" *ngIf="campo.tipo == 'num'">Numérico</td>
                    <td class="text-center" *ngIf="campo.tipo == 'date'">Fecha</td>
                    <td class="text-center" *ngIf="campo.tipo == 'scat'">Subcategoría</td>
                    <td class="text-center" *ngIf="campo.requerido"><i
                            class="fa fa-check-circle text-success fa-2x"></i>
                    </td>
                    <td class="text-center" *ngIf="!campo.requerido"><i class="fa fa-close text-danger fa-2x"></i></td>
                    <td class="text-center" *ngIf="campo.busqueda"><i class="fa fa-check-circle text-success fa-2x"></i>
                    </td>
                    <td class="text-center" *ngIf="!campo.busqueda"><i class="fa fa-close text-danger fa-2x"></i></td>
                    <td class="text-center">{{ campo.orden }}</td>
                    <td class="text-center" *ngIf="campo.activo"><i class="fa fa-check-circle text-success fa-2x"></i>
                    </td>
                    <td class="text-center" *ngIf="!campo.activo"><i class="fa fa-close text-danger fa-2x"></i></td>
                    <td class="text-center" *ngIf="campo.tipo != 'scat'">
                        <i class="fa fa-close text-danger fa-2x"></i>
                    </td>
                    <td class="text-center" *ngIf="campo.tipo == 'scat'">
                        <ngx-accordion>
                            <ngx-accordion-container>
                                <div class=" ngx-accordion-header ">
                                    <div style="color: #04447c; cursor: pointer">Ver detalle</div>
                                </div>
                                <br>
                                <div class="ngx-accordion-body">
                                    <p *ngFor="let item of campo.subcategorias">{{ item.label }}</p>
                                </div>
                            </ngx-accordion-container>
                        </ngx-accordion>
                    </td>
                    <td>
                        <i class="fa fa-pencil-square-o text-info fa-2x" aria-hidden="true" style="cursor: pointer"
                           (click)="editFieldList(editField, campo)"
                           title="Editar"></i>
                        <i *ngIf="campo.predeterminado" class="fa fa-times text-dark fa-2x" aria-hidden="true"
                           style="cursor: pointer"
                           title="Eliminar"></i>
                        <i *ngIf="!campo.predeterminado" class="fa fa-times text-danger fa-2x" aria-hidden="true"
                           style="cursor: pointer"
                           (click)="deleteFieldToList(campo)"
                           title="Eliminar"></i>
                    </td>
                </tr>

                </tbody>
            </table>
            <br>
            <div class="row">
                <div class="col-lg-6 col-12">
                    <div class="d-flex justify-content-between border-bh">
                        <div class="col-6">
                            <label class="col-form-label">Responsable:</label>
                            <ng-select class="text-left"
                                       [items]="serviceOptions"
                                       [multiple]="false"
                                       [(ngModel)]="respSelected"
                                       bindLabel="resp" [ngModelOptions]="{standalone: true}">
                            </ng-select>

                            <button class="btn bt rounded bg-primary" (click)="addRepToList()">
                                <i class="fa fa-plus"></i> Agregar
                            </button>
                        </div>

                        <div>
                            <table class="table table-sm table-light">
                                <thead>
                                <tr>
                                    <th>Lista de Responsables</th>
                                    <th>Acciones</th>
                                </tr>
                                </thead>
                                <tbody>
                                <tr *ngFor="let man of addManager">
                                    <td>{{ man.label }}</td>
                                    <td class="text-center">
                                        <i class="fa fa-times text-danger fa-2x" aria-hidden="true"
                                           style="cursor: pointer" title="Quitar de lista" (click)="deleteRep(man)"></i>
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>

                <div class="col-lg-6 col-12">
                    <div class="d-flex justify-content-center">
                        <button class="btn btn-lg rounded btn-outline-primary" (click)="openCriticality(criticality)">
                            <i class="fa fa-arrow-right"></i> Definir niveles de criticidad
                        </button>
                    </div>

                    <br>

                    <div class="d-flex justify-content-around">
                        <button type="button" class="btn btn-lg btn-primary rounded" (click)="saveList(confirmSave)">
                            <i class="fa fa-plus" aria-hidden="true"></i>Guardar
                        </button>
                        <button type="button" class="btn btn-lg btn-danger rounded" data-dismiss="modal"
                                (click)="cancel()">
                            <i class="fa fa-close" aria-hidden="true"></i> Cancelar
                        </button>
                    </div>
                </div>

            </div>
        </div>
    </div>
</div>


<ng-template #addField>
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title">Agregar Campo</h5>
            <button type="button" class="close text-white" data-dismiss="modal" aria-label="Close"
                    (click)="closeModal()" style="outline: none">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
        <div class="modal-body">
            <div class="row justify-content-center">

                <div class="col-8">
                    <ng-select class="text-left"
                               [items]="campoOptions"
                               [multiple]="false"
                               [(ngModel)]="campoSelected"
                               bindLabel="campo" [ngModelOptions]="{standalone: true}">
                    </ng-select>
                </div>
                <div class="col-2">
                    <button type="button" class="btn btn-primary rounded" (click)="verInfo()">
                        <i class="fa fa-plus" aria-hidden="true"></i> Seleccionar campo
                    </button>
                </div>
            </div>
            <br>

                    <table *ngIf="this.campoView.id !== undefined">
                        <thead class="bg-primary">
                        <tr>
                            <th width="200px" scope="col">Nombre de Campo</th>
                            <th width="100px" scope="col" class="text-center">Tipo</th>
                            <th width="75px" scope="col" class="text-center">Obligatorio</th>
                            <th width="85px" scope="col" class="text-center">Busqueda</th>
                            <th width="85px" scope="col" class="text-center">Orden</th>
                            <th width="75px" scope="col" class="text-center">Activo</th>
                            <th width="125px" scope="col" class="text-center">Subcategoria</th>
                        </tr>
                        </thead>
                        <tbody>
                        <tr>
                            <td>{{ this.campoView.label }}</td>
                            <td class="text-center" *ngIf="this.campoView.formato == 'text'">Texto</td>
                            <td class="text-center" *ngIf="this.campoView.formato == 'num'">Numérico</td>
                            <td class="text-center" *ngIf="this.campoView.formato == 'date'">Fecha</td>
                            <td class="text-center" *ngIf="this.campoView.formato == 'scat'">Subcategoría</td>
                            <td class="text-center">
                                <select [(ngModel)]="this.campoView.requerido">
                                    <option value="true">SI</option>
                                    <option value="false">NO</option>
                                </select>
                            </td>
                            <td class="text-center">
                                <select [(ngModel)]="this.campoView.busqueda">
                                    <option value="true">SI</option>
                                    <option value="false">NO</option>
                                </select>
                            </td>
                            <td width="25px" class="text-center">
                                <input style="width: 75%" [(ngModel)]="ordenCampoView" type="number" />
                            </td>
                            <td class="text-center">
                                <select [(ngModel)]="this.activeCampoView">
                                    <option value="A">Activo</option>
                                    <option value="I">Inactivo</option>
                                </select>
                            </td>
                            <td class="text-center" *ngIf="this.campoView.formato != 'scat'">
                                <i class="fa fa-close text-danger fa-2x"></i>
                            </td>
                            <td class="text-center" *ngIf="this.campoView.formato == 'scat'">

                                <ngx-accordion>
                                    <ngx-accordion-container>
                                        <div class=" ngx-accordion-header ">
                                            <div style="color: #04447c; cursor: pointer">Ver detalle</div>
                                        </div>
                                        <br>
                                        <div class="ngx-accordion-body">
                                            <p *ngFor="let item of this.campoView.subcategorias">{{ item.label }}</p>
                                        </div>
                                    </ngx-accordion-container>
                                </ngx-accordion>
                            </td>
                        </tr>
                        </tbody>
                    </table>
        </div>
        <div>

        </div>
        <div class="modal-footer">
            <button type="button" class="btn btn-sm btn-primary rounded" (click)="addFL(this.campoView)">
                <i class="fa fa-plus" aria-hidden="true"></i>Agregar
            </button>
            <button type="button" class="btn btn-sm btn-danger rounded" data-dismiss="modal"
                    (click)="closeModalAdd()">
                <i class="fa fa-close" aria-hidden="true"></i> Cancelar
            </button>
        </div>
    </div>
</ng-template>

<ng-template #editField>
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title">Editar Configuración de Campo</h5>
            <button type="button" class="close text-white" data-dismiss="modal" aria-label="Close"
                    (click)="closeModal()" style="outline: none">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>

            <div class="modal-body">

                <br>

                <table *ngIf="this.campoEdit !== undefined">
                    <thead class="bg-primary">
                    <tr>
                        <th width="200px" scope="col">Nombre de Campo</th>
                        <th width="100px" scope="col" class="text-center">Tipo</th>
                        <th width="75px" scope="col" class="text-center">Obligatorio</th>
                        <th width="85px" scope="col" class="text-center">Busqueda</th>
                        <th width="85px" scope="col" class="text-center">Orden</th>
                        <th width="75px" scope="col" class="text-center">Activo</th>
                        <th width="125px" scope="col" class="text-center">Subcategoria</th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr>
                        <td>{{ this.campoEdit.label }}</td>
                        <td class="text-center" *ngIf="this.campoEdit.formato == 'text'">Texto</td>
                        <td class="text-center" *ngIf="this.campoEdit.formato == 'num'">Numérico</td>
                        <td class="text-center" *ngIf="this.campoEdit.formato == 'date'">Fecha</td>
                        <td class="text-center" *ngIf="this.campoEdit.formato == 'scat'">Subcategoría</td>
                        <td class="text-center">
                            <select [disabled]="this.campoEdit.predeterminado" [(ngModel)]="this.campoEdit.requerido">
                                <option value="true">SI</option>
                                <option value="false">NO</option>
                            </select>
                        </td>
                        <td class="text-center">
                            <select [disabled]="this.campoEdit.predeterminado" [(ngModel)]="this.campoEdit.busqueda">
                                <option value="true">SI</option>
                                <option value="false">NO</option>
                            </select>
                        </td>
                        <td width="25px" class="text-center">
                            <input style="width: 75%" [(ngModel)]="ordenCampoEdit" type="number" />
                        </td>
                        <td class="text-center">
                            <select [(ngModel)]="this.activeCampoEdit">
                                <option value="A">Activo</option>
                                <option value="I">Inactivo</option>
                            </select>
                        </td>
                        <td class="text-center" *ngIf="this.campoEdit.formato != 'scat'">
                            <i class="fa fa-close text-danger fa-2x"></i>
                        </td>
                        <td class="text-center" *ngIf="this.campoEdit.formato == 'scat'">

                            <ngx-accordion>
                                <ngx-accordion-container>
                                    <div class=" ngx-accordion-header ">
                                        <div style="color: #04447c; cursor: pointer">Ver detalle</div>
                                    </div>
                                    <br>
                                    <div class="ngx-accordion-body">
                                        <p *ngFor="let item of this.campoEdit.subcategorias">{{ item.label }}</p>
                                    </div>
                                </ngx-accordion-container>
                            </ngx-accordion>
                        </td>
                    </tr>
                    </tbody>
                </table>

            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-sm btn-primary rounded" (click)="saveEditField()"><i class="fa fa-plus"
                                                                                aria-hidden="true"></i>
                    Actualizar
                </button>
                <button type="button" class="btn btn-sm btn-danger rounded" data-dismiss="modal" (click)="closeModal()">
                    <i class="fa fa-close" aria-hidden="true"></i> Cerrar
                </button>
            </div>

    </div>
</ng-template>

<ng-template #criticality>
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title">Niveles de Criticidad</h5>
        </div>

        <div class="modal-body">
            <div class="row justify-content-center">
                <div class="col-6">
                    <div class="form-group">
                        <label class="col-form-label">Mensaje general para la lista:</label>
                        <div class="controls">
                            <div class="input-prepend input-group">
                                <div class="input-group-prepend">
                                    <span class="input-group-text"><i class="fa fa-comment-o text-primary"></i></span>
                                </div>
                                <input [(ngModel)]="messageDft" type="text" class="form-control">
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="d-flex justify-content-around border-bh">

                <div>
                    <!--<div class="row justify-content-center">-->
                    <!--<div class="col-4">-->
                    <div class="form-group">
                        <label class="col-form-label">Nivel:</label>
                        <div class="controls">
                            <div class="input-prepend input-group">
                                <div class="input-group-prepend">
                                    <span class="input-group-text"><i class="fa fa-list-ol text-primary"></i></span>
                                </div>
                                <input [(ngModel)]="nivelNum" type="number" min="1" class="form-control">
                            </div>
                        </div>
                    </div>
                    <!--</div>-->
                    <!--<div class="col-8">-->
                    <div class="form-group">
                        <label class="col-form-label">Mensaje:</label>
                        <div class="controls">
                            <div class="input-prepend input-group">
                                <div class="input-group-prepend">
                                    <span class="input-group-text"><i class="fa fa-commenting text-primary"></i></span>
                                </div>
                                <input [(ngModel)]="nivelMsg" type="text" class="form-control">
                            </div>
                        </div>
                    </div>
                    <!--</div>-->
                    <!--</div>-->
                    <button class="btn btn-sm rounded bg-primary" (click)="addMsgToList()">
                        <i class="fa fa-plus"></i> Agregar
                    </button>
                </div>

                <div>
                    <table class="table table-sm table-light">
                        <thead>
                        <tr>
                            <th class="text-center">Nivel</th>
                            <th>Mensaje de Criticidad</th>
                            <th class="text-center">Acciones</th>
                        </tr>
                        </thead>
                        <tbody>
                        <tr *ngFor="let niv of arrayNivCrit">
                            <td class="text-center">{{ niv.id }}</td>
                            <td>
                                {{ niv.label }}
                            </td>
                            <td class="text-center">
                                <i class="fa fa-times text-danger fa-2x" aria-hidden="true" (click)="deleteNivCrit(niv)"
                                   style="cursor: pointer"
                                   title="Quitar de lista"></i>
                            </td>
                        </tr>
                        </tbody>
                    </table>
                </div>
            </div>

        </div>
        <div class="modal-footer">
            <button type="button" class="btn btn-sm btn-primary rounded" (click)="saveCriticaly()">
                <i class="fa fa-plus" aria-hidden="true"></i>Guardar
            </button>
            <button type="button" class="btn btn-sm btn-danger rounded" data-dismiss="modal" (click)="closeModal()">
                <i class="fa fa-close" aria-hidden="true"></i> Cerrar
            </button>
        </div>
    </div>
</ng-template>

<ng-template #upFile>
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title">Carga de archivo</h5>
        </div>

        <div class="modal-body">
            <div class="form-group">
                <label class="col-form-label">Seleccionar archivo:</label>
                <div class="controls">
                    <div class="input-prepend input-group">
                        <div class="input-group-prepend">
                            <span class="input-group-text"><i class="fa fa-bars text-primary"></i></span>
                        </div>
                        <input type="file" (change)="onFileChange($event)" class="form-control">
                    </div>
                </div>
            </div>
        </div>

        <div class="modal-footer">
            <button type="button" class="btn btn-sm btn-primary rounded" (click)="uploadFile($event)"><i class="fa fa-plus" aria-hidden="true"></i>
                Subir
            </button>
            <button type="button" class="btn btn-sm btn-danger rounded" data-dismiss="modal" (click)="closeModal()">
                <i class="fa fa-close" aria-hidden="true"></i> Cerrar
            </button>
        </div>
    </div>
</ng-template>

<ng-template #confirmSave>
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title">Confirmar</h5>
        </div>

        <div class="modal-body">
            <h4 class="text-center">Esta seguro de guardar la lista sin definir niveles de criticidad?</h4>
        </div>

        <div class="modal-footer">
            <button type="button" class="btn btn-sm btn-primary rounded" (click)="saveModal()">
                <i class="fa fa-plus" aria-hidden="true"></i>
                Actualizar
            </button>
            <button type="button" class="btn btn-sm btn-danger rounded" data-dismiss="modal" (click)="closeModal()">
                <i class="fa fa-close" aria-hidden="true"></i> Cancelar
            </button>
        </div>
    </div>
</ng-template>
